Index: trunk/drmaa_utils/drmaa_utils/exception.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/exception.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/exception.h	(revision 1)
@@ -0,0 +1,257 @@
+/* $Id: exception.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__EXCEPTION_H
+#define __DRMAA_UTILS__EXCEPTION_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <stdarg.h>
+#include <setjmp.h>
+
+#include <drmaa_utils/compat.h>
+
+#if defined(__GNUC__) && defined(DEBUGGING)
+extern int setjmp( jmp_buf __env )
+		__attribute__(( returns_twice ));
+#endif
+
+
+/** Exception type. */
+typedef struct fsd_exc_s fsd_exc_t;
+
+fsd_exc_t *
+fsd_exc_new( int code, char *message, bool own_message );
+
+/** Exception structure. */
+struct fsd_exc_s {
+	int (*code)( const fsd_exc_t* );
+	const char* (*message)( const fsd_exc_t* );
+	void (*destroy)( fsd_exc_t* );
+
+	int _code;
+	char *_message;
+	bool _own_message;
+	bool _own_self;
+};
+
+void
+fsd_exc_raise( fsd_exc_t *exc )
+		__attribute__(( noreturn ));
+
+void
+fsd_exc_raise_code( int error_code )
+		__attribute__(( noreturn ));
+
+void
+fsd_exc_raise_msg( int error_code, const char *message )
+		__attribute__(( noreturn ));
+
+void
+fsd_exc_raise_fmt( int error_code, const char *fmt, ... )
+		__attribute__(( noreturn, format( printf, 2, 3 ) ));
+
+void
+fsd_exc_raise_fmtv( int error_code, const char *fmt, va_list args )
+		__attribute__(( noreturn ));
+
+void
+fsd_exc_raise_sys( int errno_code )
+		__attribute__(( noreturn ));
+
+void
+fsd_exc_reraise(void)
+		__attribute__(( noreturn ));
+
+const fsd_exc_t *
+fsd_exc_get(void);
+
+void
+fsd_exc_clear(void);
+
+
+#define TRY \
+	 { \
+		fsd_exc_try_block_t* volatile _fsd_exc_try_block = NULL; \
+		int _fsd_exc_rc; \
+		_fsd_exc_try_block = fsd_exc_try( __FUNCTION__, __LINE__ ); \
+		if( _fsd_exc_try_block != NULL ) \
+			_fsd_exc_rc = setjmp( _fsd_exc_try_block->env ); \
+		else \
+			_fsd_exc_rc = FSD_ERRNO_EXC_END; \
+		while(1) \
+		 { \
+			bool _fsd_exc_handled = false; \
+			fsd_exc_control( _fsd_exc_try_block, &_fsd_exc_rc ); \
+			if( _fsd_exc_rc == FSD_ERRNO_EXC_END ) \
+				break; \
+			switch( _fsd_exc_rc ) \
+			 { \
+				case 0: {
+#define EXCEPT(error_code) \
+				 } break; \
+				case error_code: { \
+					_fsd_exc_handled = true;
+#define EXCEPT_DEFAULT \
+				 } break; \
+				default: \
+					if( _fsd_exc_rc > 0 ) \
+					 { \
+						_fsd_exc_handled = true;
+#define FINALLY \
+				 } break; \
+				case FSD_ERRNO_EXC_FINALLY: {
+#define ELSE \
+				 } break; \
+				case FSD_ERRNO_EXC_ELSE: {
+#define END_TRY \
+				 } break; \
+			 } \
+			if( _fsd_exc_handled ) \
+			 { \
+				fsd_assert( _fsd_exc_try_block->handled_exc != NULL ); \
+				_fsd_exc_try_block->handled_exc->destroy( \
+						_fsd_exc_try_block->handled_exc ); \
+				_fsd_exc_try_block->handled_exc = NULL; \
+			 } \
+		 } \
+	 }
+
+
+/** The state of exception handling block. */
+typedef enum {
+	FSD_EXC_ENTER, /**< Before try. */
+	FSD_EXC_TRY_BLOCK, /**< Insidie try-block. */
+	FSD_EXC_EXCEPTION_HANDLE, /**< Inside exception handling block. */
+	FSD_EXC_ELSE_BLOCK, /**< Inside else-block. */
+	FSD_EXC_FINALLY_BLOCK, /**< Inside finally block. */
+	FSD_EXC_LEAVE /**< Leaving try/except/finally block (after finally). */
+} fsd_exc_try_block_state_t;
+
+/**
+ * Try/except/else/finally block data structure.
+ * Holds the state for exception handling module.
+ *
+ * It also represents a point on the stack and other state of
+ * thread to wich it can be restored during "stack rollback"
+ * process after exception is raised.
+ */
+typedef struct fsd_exc_try_block_s {
+	jmp_buf env;  /**< Stack restore point for \c longjmp. */
+	fsd_exc_t *handled_exc; /**< Exception handled within block */
+	fsd_exc_try_block_state_t state;
+	const char *function; /**< Name of function */
+	int lineno; /**< Line number where try-block starts */
+} fsd_exc_try_block_t;
+
+
+fsd_exc_try_block_t *
+fsd_exc_try( const char *function, int lineno );
+
+void
+fsd_exc_control( fsd_exc_try_block_t *block, int *rc );
+
+
+const char *
+fsd_strerror( int error_code );
+
+/** Error codes. */
+typedef enum {
+	FSD_ERRNO_SUCCESS                    =  0,
+
+	FSD_ERRNO_EXC_ELSE                   = -1,
+	FSD_ERRNO_EXC_FINALLY                = -2,
+	FSD_ERRNO_EXC_END                    = -3,
+
+	/* _FSD_ERRNO_START = 1000, */
+
+	FSD_ERRNO_INTERNAL_ERROR             = 1001,
+	FSD_ERRNO_NO_MEMORY                  = 1002,
+	FSD_ERRNO_INVALID_ARGUMENT           = 1003,
+	FSD_ERRNO_INVALID_VALUE              = 1004,
+	FSD_ERRNO_INVALID_VALUE_FORMAT       = 1005,
+	FSD_ERRNO_STOP_ITERATION             = 1006,
+	FSD_ERRNO_NOT_IMPLEMENTED            = 1007,
+	FSD_ERRNO_NOT_INITIALIZED            = 1008,
+	FSD_ERRNO_TIMEOUT                    = 1009,
+	FSD_ERRNO_AUTH_FAILURE               = 1010,
+	FSD_ERRNO_AUTHZ_FAILURE              = 1011,
+	FSD_ERRNO_TRY_LATER                  = 1012,
+
+	FSD_ERRNO_DRM_COMMUNICATION_FAILURE  = 1013,
+	FSD_ERRNO_DRMS_INIT_FAILED           = 1014,
+	FSD_ERRNO_DRMS_EXIT_ERROR            = 1015,
+	FSD_ERRNO_DENIED_BY_DRM              = 1016,
+
+	/* DRMAA specific error codes: */
+	FSD_DRMAA_ERRNO_NO_ACTIVE_SESSION                    = 1032,
+	FSD_DRMAA_ERRNO_INVALID_CONTACT_STRING               = 1033,
+	FSD_DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR         = 1034,
+	FSD_DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED   = 1035,
+	FSD_DRMAA_ERRNO_ALREADY_ACTIVE_SESSION               = 1036,
+	FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT             = 1037,
+	FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE              = 1038,
+	FSD_DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES         = 1039,
+	FSD_DRMAA_ERRNO_INVALID_JOB                          = 1040,
+	FSD_DRMAA_ERRNO_RESUME_INCONSISTENT_STATE            = 1041,
+	FSD_DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE           = 1042,
+	FSD_DRMAA_ERRNO_HOLD_INCONSISTENT_STATE              = 1043,
+	FSD_DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE           = 1044,
+	FSD_DRMAA_ERRNO_EXIT_TIMEOUT                         = 1045,
+	FSD_DRMAA_ERRNO_NO_RUSAGE                            = 1046,
+
+	/* ARes specific error codes: */
+	FSD_ARES_ERRNO_INVALID_CONTACT_STRING                = 1052,
+	FSD_ARES_ERRNO_INVALID_ATTRIBUTE_FORMAT              = 1053,
+	FSD_ARES_ERRNO_INVALID_ATTRIBUTE_VALUE               = 1054,
+	FSD_ARES_ERRNO_CONFLICTING_ATTRIBUTE_VALUES          = 1055,
+	FSD_ARES_ERRNO_INVALID_ARES                          = 1056,
+
+	FSD_MIN_ERRNO = FSD_ERRNO_INTERNAL_ERROR,
+	FSD_MAX_ERRNO = FSD_ARES_ERRNO_INVALID_ARES
+} fsd_errno_t;
+
+
+#ifndef NDEBUG
+#	define fsd_assert( precondition ) \
+		do { \
+			if( ! (precondition) ) \
+				fsd_assertion_failed( __FILE__, __LINE__, \
+						__FUNCTION__, #precondition ); \
+		} while(0)
+#else
+#	define fsd_assert( precondition )  do{/* nothing */}while(0)
+#endif
+
+void
+fsd_assertion_failed( const char *file, int lineno,
+		const char *function, const char *precondition )
+		__attribute__(( noreturn ));
+
+void *
+fsd_exc_try_except(
+		void*(*f)(void*), void *data,
+		int *error_code,
+		char **error_message
+		);
+
+#endif /* __DRMAA_UTILS__EXCEPTION_H */
+
Index: trunk/drmaa_utils/drmaa_utils/iter.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/iter.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/iter.c	(revision 1)
@@ -0,0 +1,145 @@
+/* $Id: iter.c 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+
+#include <drmaa_utils/iter.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: iter.c 2 2009-10-12 09:51:22Z mamonski $";
+#endif
+
+
+static const char *
+fsd_iter_next( fsd_iter_t *self )
+{
+	if( self->_position < self->_length )
+		return self->_list[ self->_position++ ];
+	else
+		fsd_exc_raise_code( FSD_ERRNO_STOP_ITERATION );
+}
+
+static void
+fsd_iter_reset( fsd_iter_t *self )
+{
+	self->_length = 0;
+}
+
+static int
+fsd_iter_len( fsd_iter_t *self )
+{
+	return self->_length;
+}
+
+static void
+fsd_iter_append( fsd_iter_t *self, char *string )
+{
+	TRY
+	 {
+		if( !self->_own_list )
+			fsd_exc_raise_msg(
+					FSD_ERRNO_INTERNAL_ERROR,
+					"iter::append called on constant list" );
+		fsd_realloc( self->_list, self->_length+1, char* );
+		self->_list[ self->_length++ ] = string;
+	 }
+	EXCEPT_DEFAULT
+	 {
+		fsd_free( string );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+}
+
+static void
+fsd_iter_destroy( fsd_iter_t *self )
+{
+	int i;
+	if( self->_own_list  &&  self->_list )
+	 {
+		for( i = 0;  i < self->_length;  i++ )
+			fsd_free( self->_list[i] );
+		fsd_free( self->_list );
+	 }
+	fsd_free( self );
+}
+
+static fsd_iter_t *
+fsd_iter_new_impl( char **list, int length, bool own )
+{
+	fsd_iter_t *volatile self = NULL;
+	TRY
+	 {
+		fsd_malloc( self, fsd_iter_t );
+		self->next = fsd_iter_next;
+		self->reset = fsd_iter_reset;
+		self->len = fsd_iter_len;
+		self->append = fsd_iter_append;
+		self->destroy = fsd_iter_destroy;
+		self->_list = list;
+		self->_position = 0;
+		if( list == NULL )
+			self->_length = 0;
+		else if( length >= 0 )
+			self->_length = length;
+		else
+		 {
+			char **i;
+			int cnt = 0;
+			for( i = self->_list;  *i != NULL;  i++ )
+				cnt++;
+			self->_length = cnt;
+		 }
+		self->_own_list = own;
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( own  &&  list )
+		 {
+			if( length >= 0 )
+			 {
+				int i;
+				for( i = 0;  i < length;  i++ )
+					fsd_free( list[i] );
+				fsd_free( list );
+			 }
+			else
+				fsd_free_vector( list );
+		 }
+		fsd_exc_reraise();
+	 }
+	END_TRY
+	return self;
+}
+
+fsd_iter_t *
+fsd_iter_new( char **list, int length )
+{
+	return fsd_iter_new_impl( list, length, true );
+}
+
+fsd_iter_t *
+fsd_iter_new_const( const char *const *list, int length )
+{
+	return fsd_iter_new_impl( (char**)list, length, false );
+}
+
Index: trunk/drmaa_utils/drmaa_utils/timedelta.rl
===================================================================
--- trunk/drmaa_utils/drmaa_utils/timedelta.rl	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/timedelta.rl	(revision 1)
@@ -0,0 +1,79 @@
+/* $Id: timedelta.rl 1452 2008-10-02 12:09:09Z lukasz $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <string.h>
+
+#include <drmaa_utils/common.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: timedelta.rl 1452 2008-10-02 12:09:09Z lukasz $";
+#endif
+
+int
+fsd_parse_timedelta( const char *string )
+{
+	%%{
+		machine fsd_timedelta;
+		action error {
+			fsd_exc_raise_fmt(
+					FSD_ERRNO_INVALID_VALUE_FORMAT,
+					"time delta syntax error: %s", string );
+		}
+		action next_field {
+			fields[ n_fields++ ] = v;
+		}
+		integer = [0-9]+ >{ v = 0; } ${ v *= 10;  v += fc - '0'; };
+		timedelta = integer %next_field (':' integer %next_field){1,2};
+		main := timedelta @eof(error) $err(error);
+	}%%
+
+	%%write data;
+	int v = 0;
+	int fields[3];
+	int n_fields = 0;
+	int timedelta;
+	int i;
+
+	const char *p = string;
+	const char *pe = p + strlen(p);
+	const char *eof = pe;
+	int cs;
+
+	fsd_log_enter(( "(%s)", string ));
+	%%write init;
+	%%write exec;
+	timedelta = 0;
+	for( i = 0;  i < n_fields;  i++ )
+	 {
+		timedelta *= 60;
+		timedelta += fields[i];
+	 }
+	fsd_log_return(( " =%d", timedelta ));
+	return timedelta;
+}
+
+/* vim: set ft=ragel: */
Index: trunk/drmaa_utils/drmaa_utils/iter.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/iter.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/iter.h	(revision 1)
@@ -0,0 +1,49 @@
+/* $Id: iter.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__ITER_H
+#define __DRMAA_UTILS__ITER_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/common.h>
+
+fsd_iter_t *
+fsd_iter_new( char **list, int length );
+
+fsd_iter_t *
+fsd_iter_new_const( const char *const *list, int length );
+
+struct fsd_iter_s {
+	const char* (*next)( fsd_iter_t *self );
+	void (*reset)( fsd_iter_t *self );
+	int (*len)( fsd_iter_t *self );
+	void (*append)( fsd_iter_t *self, char *string );
+	void (*destroy)( fsd_iter_t *self );
+	
+	char **_list;
+	int _position;
+	int _length;
+	bool _own_list;
+};
+
+#endif /* __DRMAA_UTILS__ITER_H */
+
Index: trunk/drmaa_utils/drmaa_utils/template.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/template.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/template.c	(revision 1)
@@ -0,0 +1,180 @@
+/* $Id: template.c 284 2010-09-13 08:39:55Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+#include <drmaa_utils/template.h>
+#include <drmaa_utils/util.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: template.c 284 2010-09-13 08:39:55Z mmatloka $";
+#endif
+
+
+static const char*
+fsd_template_get_attr( const fsd_template_t *self, const char *name )
+{
+	const fsd_attribute_t *attr = NULL;
+	if( name == NULL )
+		fsd_exc_raise_code( FSD_ERRNO_INVALID_ARGUMENT );
+	attr = self->by_name( self, name );
+	if( attr == NULL  ||  attr->is_vector )
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid scalar attribute name: %s", name
+				);
+	return (const char*) self->attributes[ attr->code ];
+}
+
+
+static void
+fsd_template_set_attr( fsd_template_t *self,
+		const char *name, const char *value )
+{
+	const fsd_attribute_t *attr = NULL;
+	fsd_log_enter(("(%s=%s)", name, value));
+	if( name == NULL )
+		fsd_exc_raise_code( FSD_ERRNO_INVALID_ARGUMENT );
+	attr = self->by_name( self, name );
+	if( attr == NULL  ||  attr->is_vector )
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid scalar attribute name: %s", name
+				);
+	if( value != NULL ) {
+		if( self->attributes[ attr->code ] != NULL ) {
+			fsd_free(self->attributes[ attr->code ]);
+		}
+		self->attributes[ attr->code ] = fsd_strdup( value );
+	}
+	else
+		self->attributes[ attr->code ] = NULL;
+}
+
+
+static const char* const*
+fsd_template_get_v_attr( const fsd_template_t *self, const char *name )
+{
+	const fsd_attribute_t *attr = NULL;
+	if( name == NULL )
+		fsd_exc_raise_code( FSD_ERRNO_INVALID_ARGUMENT );
+	attr = self->by_name( self, name );
+	if( attr == NULL  ||  ! attr->is_vector )
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid vector attribute name: %s", name
+				);
+	return (const char* const*) self->attributes[ attr->code ];
+}
+
+
+static void
+fsd_template_set_v_attr( fsd_template_t *self,
+		const char *name, const char **value )
+{
+	const fsd_attribute_t *attr = NULL;
+	char **volatile v = NULL;
+
+	if( name == NULL )
+		fsd_exc_raise_code( FSD_ERRNO_INVALID_ARGUMENT );
+	attr = self->by_name( self, name );
+	if( attr == NULL  ||  ! attr->is_vector )
+		fsd_exc_raise_fmt(
+				FSD_ERRNO_INVALID_ARGUMENT,
+				"invalid vector attribute name: %s", name
+				);
+
+	TRY
+	 {
+		int code = attr->code;
+		if( value != NULL )
+			v = fsd_copy_vector( value );
+		if( self->attributes[code] != NULL )
+			fsd_free_vector( self->attributes[code] );
+		self->attributes[code] = v;  v = NULL;
+	 }
+	FINALLY
+	 { fsd_free_vector( v ); }
+	END_TRY
+}
+
+
+static void
+fsd_template_destroy( fsd_template_t *self )
+{
+	unsigned i;
+	for( i = 0;  i < self->n_attributes;  i++ )
+		if( self->attributes[i] != NULL )
+		 {
+			const fsd_attribute_t *attr;
+			attr = self->by_code( self, i );
+			if( attr )
+			 {
+				if( attr->is_vector )
+					fsd_free_vector( self->attributes[i] );
+				else
+					fsd_free( self->attributes[i] );
+			 }
+		 }
+	fsd_free( self->attributes );
+	fsd_free( self );
+}
+
+
+fsd_template_t *
+fsd_template_new(
+		fsd_template_by_name_method *by_name_method,
+		fsd_template_by_code_method *by_code_method,
+		unsigned n_attributes
+		)
+{
+	fsd_template_t *volatile self = NULL;
+	TRY
+	 {
+		fsd_malloc( self, fsd_template_t );
+		self->attributes = NULL;
+		self->n_attributes = 0;
+		self->get_attr = fsd_template_get_attr;
+		self->set_attr = fsd_template_set_attr;
+		self->get_v_attr = fsd_template_get_v_attr;
+		self->set_v_attr = fsd_template_set_v_attr;
+		self->by_name = by_name_method;
+		self->by_code = by_code_method;
+		self->destroy = fsd_template_destroy;
+
+		fsd_calloc( self->attributes, n_attributes, void* );
+		self->n_attributes = n_attributes;
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( self )
+			self->destroy( self );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+	return self;
+}
+
Index: trunk/drmaa_utils/drmaa_utils/job.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/job.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/job.h	(revision 1)
@@ -0,0 +1,246 @@
+/* $Id: job.h 255 2010-08-05 15:53:36Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file job.h
+ * Job managing functions.
+ */
+
+#ifndef __DRMAA_UTILS__JOB_H
+#define __DRMAA_UTILS__JOB_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <sys/time.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/thread.h>
+
+/**
+ * Create new job structure.
+ * @return Sole reference to newly created job.
+ */
+fsd_job_t *
+fsd_job_new( char *job_id );
+
+/** Job state flags. */
+typedef enum {
+	/**
+	 * Job is in queued state (either active or hold in queue).
+	 */
+	FSD_JOB_QUEUED             = 1<<0,
+	/** Job is hold in queue. */
+	FSD_JOB_HOLD               = 1<<1,
+	/** Job is running (suspended or not). */
+	FSD_JOB_RUNNING            = 1<<2,
+	/**
+	 * Set when job was suspended within session by
+	 * drmaa_control(DRMAA_CONTROL_SUSPEND).
+	 */
+	FSD_JOB_SUSPENDED          = 1<<3,
+	/**
+	 * Whether we know that job terminated and its status
+	 * is waiting to rip.
+	 */
+	FSD_JOB_TERMINATED         = 1<<4,
+	/**
+	 * It is known that job was aborted by user.
+	 */
+	FSD_JOB_ABORTED            = 1<<5,
+
+	/**
+	 * Job was submitted in current session.
+	 * It is set for all jobs which are or was
+	 * in fsd_drmaa_session_t#jobs set.
+	 */
+	FSD_JOB_CURRENT_SESSION    = 1<<6,
+
+	/**
+	 * Job is removed from session (but references to job still
+	 * exist).  No such job shall exist in session's submited
+	 * jobs set.
+	 */
+	FSD_JOB_DISPOSED           = 1<<7,
+
+	FSD_JOB_MISSING            = 1<<8,
+
+	FSD_JOB_QUEUED_MASK      = FSD_JOB_QUEUED | FSD_JOB_HOLD,
+	FSD_JOB_RUNNING_MASK     = FSD_JOB_RUNNING | FSD_JOB_SUSPENDED,
+	FSD_JOB_TERMINATED_MASK  = FSD_JOB_TERMINATED | FSD_JOB_ABORTED,
+	FSD_JOB_STATE_MASK       = FSD_JOB_HOLD | FSD_JOB_RUNNING
+		| FSD_JOB_SUSPENDED | FSD_JOB_TERMINATED
+} fsd_job_flag_t;
+
+
+/** Submitted job data. */
+struct fsd_job_s {
+	/** Release reference to job. */
+	void (*release)( fsd_job_t *self );
+
+	/** Destroy job data. */
+	void (*destroy)( fsd_job_t *self );
+
+	/** Implements drmaa_control(). */
+	void (*control)( fsd_job_t *self, int action );
+
+	/** Fetch job state from DRM. */
+	void (*update_status)( fsd_job_t *self );
+
+	/** Return job termination status and resource usage for drmaa_wait(). */
+	void (*get_termination_status)( fsd_job_t *self,
+			int *status, fsd_iter_t **rusage_out );
+
+	/**
+	 * Called whenever job is detected to be missing from DRM queue
+	 * while stil being within DRMAA session.
+	 */
+	void (*on_missing)( fsd_job_t *self );
+
+	/**
+	 * Points to next job in list.
+	 * Used by #fsd_job_set_t.
+	 */
+	fsd_job_t *next;
+
+	/** Number of references. */
+	int ref_cnt;
+
+	/** Job identifier (as null terminated string). */
+	char *job_id;
+
+	/** DRMAA session which job was submitted in. */
+	fsd_drmaa_session_t *session;
+
+	/**
+	 * Time of last update of job status and rusage information
+	 * (when status, exit_status, cpu_usage, mem_usage and flags
+	 * fields was updated according to DRM).
+	 */
+	time_t last_update_time;
+
+	/** Job state flags.  @see job_flag_t */
+	unsigned flags;
+
+	/**
+	 * State of job (as returned by drmaa_job_ps())
+	 * from last retrieval from DRM.
+	 */
+	int state;
+
+	/** Exit status of job as from <tt>wait(2)</tt>. */
+	int exit_status;
+	/** Time of job submission (local). */
+	time_t submit_time;
+	/** Time when job started execution (taken from DRM). */
+	time_t start_time;
+	/** Time when job ended execution (taken from DRM). */
+	time_t end_time;
+	/** CPU time usage in seconds. */
+	long cpu_usage;
+	/** Resident memory usage in bytes. */
+	long mem_usage;
+	/** Virtual memory usage in bytes. */
+	long vmem_usage;
+	/** Total run time in seconds. */
+	long walltime;
+	/** List of space separated execution host names. */
+	char *execution_hosts;
+	/** Batch queue name */
+	char *queue;
+	/** Account string */
+	char *project;
+
+	/** Mutex for accessing fsd_job_s structure (beside #next pointer). */
+	fsd_mutex_t  mutex;
+	/** Job status changed condition. */
+	fsd_cond_t   status_cond;
+	/** Able to destroy condition variable (ref_cnt==1). */
+	fsd_cond_t   destroy_cond;
+};
+
+
+
+/** Create empty set of jobs. */
+fsd_job_set_t *
+fsd_job_set_new(void);
+
+struct fsd_job_set_s {
+	/** Destroy set of jobs (including contained job handles). */
+	void (*
+	destroy)( fsd_job_set_t *self );
+
+	/** Adds job to set. */
+	void (*
+	add)( fsd_job_set_t *self, fsd_job_t *job );
+
+	/** Remove job from set. */
+	void (*
+	remove)( fsd_job_set_t *self, fsd_job_t *job );
+
+	/**
+	 * Finds job with given job_id.
+	 * @param job_set Set of jobs to search in.
+	 * @param job_id Job identifier.
+	 * @return If successful job handle is returned
+	 * and caller have exclusive access right to it.
+	 * It should be released by #release().
+	 * \c NULL is returned when job was not found.
+	 */
+	fsd_job_t* (*
+	get)( fsd_job_set_t *self, const char *job_id );
+
+	/** Whether the set is empty. */
+	bool (*
+	empty)( fsd_job_set_t *self );
+
+	/**
+	 * Find any job in set which was terminated (either successfully or not).
+	 * It is usefull for drmaa_wait( DRMAA_JOB_IDS_ANY ) implementation.
+	 * @param job_set Set of jobs to search in.
+	 * @return New reference to terminated job
+	 *   or \c NULL if no such job is present in set.
+	 * @see fsd_job_find
+	 */
+	fsd_job_t* (*
+	find_terminated)( fsd_job_set_t *self );
+
+	/**
+	 * Return idenetifiers of all jobs in set.
+	 * @param job_set Set of jobs.
+	 * @return Vector of job idenetifiers
+	 *   when done free it with fsd_free_vector.
+	 */
+	char** (*
+	get_all_job_ids)( fsd_job_set_t *self );
+
+	void (*
+	signal_all)( fsd_job_set_t *self );
+
+	fsd_job_t    **tab;
+	size_t         tab_size;
+	uint32_t       tab_mask;
+	/** Number of jobs in set. */
+	unsigned       n_jobs;
+	/** Mutex for job set data (e.g. for adding/removing job from set). */
+	fsd_mutex_t    mutex;
+};
+
+#endif /* __DRMAA_UTILS__JOB_H */
Index: trunk/drmaa_utils/drmaa_utils/template.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/template.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/template.h	(revision 1)
@@ -0,0 +1,77 @@
+/* $Id: template.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__TEMPLATE_H
+#define __DRMAA_UTILS__TEMPLATE_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/common.h>
+
+typedef const fsd_attribute_t *
+fsd_template_by_name_method( const fsd_template_t *self, const char *name );
+
+typedef const fsd_attribute_t *
+fsd_template_by_code_method( const fsd_template_t *self, int code );
+
+
+fsd_template_t *
+fsd_template_new(
+		fsd_template_by_name_method *by_name_method,
+		fsd_template_by_code_method *by_code_method,
+		unsigned n_attributes
+		);
+
+struct fsd_template_s {
+	const char* (*
+	get_attr)( const fsd_template_t *self, const char *name );
+
+	void (*
+	set_attr)( fsd_template_t *self, const char *name, const char *value );
+
+	const char* const* (*
+	get_v_attr)( const fsd_template_t *self, const char *name );
+
+	void (*
+	set_v_attr)( fsd_template_t *self, const char *name, const char **value );
+
+	const fsd_attribute_t* (*
+	by_name)( const fsd_template_t *self, const char *name ); 
+
+	const fsd_attribute_t* (*
+	by_code)( const fsd_template_t *self, int code );
+
+	void (*
+	destroy)( fsd_template_t *self );
+
+	void **attributes;
+	unsigned n_attributes;
+};
+
+struct fsd_attribute_s {
+	const char *name;
+	int code;
+	bool is_vector;
+};
+
+
+#endif /* __DRMAA_UTILS__TEMPLATE_H */
+
